#------------------------------------------------------------------------------
#    plSokoban Suite - perl OOP sokoban implementation
#    Copyright (c) 2002 Arne Bochem <webmaster@arneb.de>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#------------------------------------------------------------------------------

use strict;
use Sokoban::Element;

package Sokoban::Element::Empty;
@Sokoban::Element::Empty::ISA = qw( Sokoban::Element );

sub free
{
	return(1);
}

sub move
{
	return(1);
}

sub redefine
{
	my ($self, $element_type) = @_;

	($self->{'_target'} and ($element_type eq 'x')) and $self->{'_parent'}->boulder_hit();
	$self->{'_parent'}->redefine($self, $element_type);
}

sub element_type
{
	my $self = shift;
	$self->{'_target'} and return('o');
	return $self->{'_element_type'};
}

1;
